VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "program wrapper"
   ClientHeight    =   210
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4680
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   210
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   4000
      Left            =   4380
      Top             =   60
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Const NORMAL_PRIORITY_CLASS = &H20&
Private Const IDLE_PRIORITY_CLASS = &H40&
Private Const HIGH_PRIORITY_CLASS = &H80
Private Const REALTIME_PRIORITY_CLASS = &H100
Private Const PROCESS_DUP_HANDLE = &H40
Private Const BELOW_NORMAL_PRIORITY_CLASS = 16384
Private Const ABOVE_NORMAL_PRIORITY_CLASS = 32768

Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function GetCurrentProcessId Lib "kernel32" () As Long
Private Declare Function SetPriorityClass& Lib "kernel32" (ByVal hProcess As Long, ByVal dwPriorityClass As Long)

Private Declare Function CreateProcess Lib "kernel32" Alias _
    "CreateProcessA" (ByVal lpApplicationName As String, ByVal _
    lpCommandLine As String, lpProcessAttributes As Any, _
    lpThreadAttributes As Any, ByVal bInheritHandles As Long, ByVal _
    dwCreationFlags As Any, lpEnvironment As Any, ByVal _
    lpCurrentDriectory As String, lpStartupInfo As STARTUPINFO, _
    lpProcessInformation As PROCESS_INFORMATION) As Long

Private Type STARTUPINFO
        cb As Long
        lpReserved As String
        lpDesktop As String
        lpTitle As String
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Byte
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type

Private Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type

Private pInfo As PROCESS_INFORMATION
Private sInfo As STARTUPINFO
Private sNull As String

Dim processId As Long

Private Sub Form_Load()
On Error Resume Next
    Dim hProcess As Long
    Dim ret As Long
    
    If Command$ <> "" Then
        ''''processId = Shell("""" & "C:\Documents and Settings\Administrator\Desktop\mlbDude ffmpeg compressor\ffmpeg" & """" & " -i " & """" & "C:\Documents and Settings\Administrator\Desktop\share\TheSimpsonsLisaGetsanA-3393418-0.mpg" & """" & " -deinterlace -y -f avi -vcodec mpeg4 -b 1800 -g 300 -bf 2 -acodec mp2 -ab 192 " & """" & ".\Library\The Simpsons\TheSimpsonsLisaGetsanA-3393418-0.avi" & """", vbNormalFocus)
        Dim Extern_FOCUS As String
        
        Extern_FOCUS = GetINIVal("Extern_run_minimized_no_focus", App.Path & "\" & App.EXEName & ".properties")
        
        If UCase(Extern_FOCUS) = "TRUE" Then
            processId = Shell(Command$, vbMinimizedNoFocus)
        Else
            processId = Shell(Command$, vbNormalFocus)
        End If
        
        hProcess = OpenProcess(PROCESS_DUP_HANDLE, True, processId)
    Else
        Dim Java_EXE As String
        Dim Java_CLASSPATH As String
        Dim Java_CLASS As String
        Dim Java_ARGS As String
        Dim exe_line As String
        Dim Java_FOCUS As String
        
        Java_EXE = GetINIVal("Java_Executable_Path", App.Path & "\" & App.EXEName & ".properties")
        Java_CLASSPATH = GetINIVal("Class_path_to_use", App.Path & "\" & App.EXEName & ".properties")
        Java_CLASS = GetINIVal("Class_to_run", App.Path & "\" & App.EXEName & ".properties")
        Java_ARGS = GetINIVal("Args_if_any", App.Path & "\" & App.EXEName & ".properties")
        Java_FOCUS = GetINIVal("Java_run_minimized_no_focus", App.Path & "\" & App.EXEName & ".properties")

        If Java_CLASSPATH = "" Then
            Java_CLASSPATH = "."
        End If
        
        If Java_ARGS = "" Then
            exe_line = Java_EXE & " -classpath " & Java_CLASSPATH & " " & Java_CLASS
        Else
            exe_line = Java_EXE & " -classpath " & Java_CLASSPATH & " " & Java_CLASS & " " & Java_ARGS
        End If
        
        'got instrunctions how to do this off msdn
        sInfo.cb = Len(sInfo)
        
        If UCase(Java_FOCUS) = "TRUE" Then
            'sInfo.wShowWindow = vbMinimizedNoFocus
            'ret = CreateProcess(sNull, exe_line, ByVal 0&, ByVal 0&, 1&, IDLE_PRIORITY_CLASS, ByVal 0&, App.Path, sInfo, pInfo)
            processId = Shell(exe_line, vbMinimizedNoFocus)
        Else
            'sInfo.wShowWindow = vbNormalFocus
            'ret = CreateProcess(sNull, exe_line, ByVal 0&, ByVal 0&, 1&, IDLE_PRIORITY_CLASS, ByVal 0&, App.Path, sInfo, pInfo)
            processId = Shell(exe_line, vbNormalFocus)
        End If
            
        'hProcess = pInfo.hProcess
        'processId = pInfo.dwProcessId
        
        hProcess = OpenProcess(PROCESS_DUP_HANDLE, True, processId)
    End If
        
    If hProcess <> 0 Then
        SetPriorityClass hProcess, IDLE_PRIORITY_CLASS
    End If
            
    ret = CloseHandle(hProcess)
    ret = CloseHandle(pInfo.hThread)
    
    Me.Hide
    Timer1_Timer
End Sub

Private Sub Timer1_Timer()
    Dim hProcess As Long
    Dim ret As Long
    
    'check if process id still exists
    hProcess = OpenProcess(PROCESS_DUP_HANDLE, True, processId)
    
    If hProcess = 0 Then
        Unload Me   'the process is no longer open
    End If
    
    ret = CloseHandle(hProcess)
End Sub
